<?php
if ( defined('MODULE_HEADER_TAGS_HONEYPOT_STATUS') && MODULE_HEADER_TAGS_HONEYPOT_STATUS == 'True') {  

    $allowed_pages = explode(';', MODULE_HEADER_TAGS_HONEYPOT_PAGES);    
    $page = basename($_SERVER['SCRIPT_FILENAME']);
        
    if (in_array($page, $allowed_pages)) { 

        if (! $error) {	
            include_once('includes/languages/' . $language . '/honeypot.php'); 
            include_once('includes/functions/honeypot.php'); 
            
            if (defined('MODULE_HEADER_TAGS_HONEYPOT_VERIFY_TIME_TO_SUBMIT') && tep_not_null(MODULE_HEADER_TAGS_HONEYPOT_VERIFY_TIME_TO_SUBMIT)) {
                if (! isset($_SESSION['time_check'])) {
                    $time_check = time(); 
                    $_SESSION['time_check'] = $time_check;   
                } else if (CheckTimeToSubmit()) {  
                    WriteToLog(TEXT_CHECK_TIME_TO_SUBMIT);   
                    $error = true;
                } 
            }    
        
            if (CheckCaptcha()) {
                WriteToLog(TEXT_CREATE_ACCOUNT_CAPTCHA); 
                $form_name = GetFormName($page);
                $messageStack->add($form_name, TEXT_HONEYPOT_SECURITY_ANSWER_FAILURE);
                $error = true;     
            }    
        
            if (! $error) {  //if set above, skip the rest
                $this_error = false;
                
                if (MODULE_HEADER_TAGS_HONEYPOT_USE_IPLIST != 'None') {
                    $this_error = CheckBlackLists();
                    if ($this_error) {
                        WriteToLog(TEXT_CREATE_ACCOUNT_IPLIST);
                        $error = true;
                    }	
                }            
                 
                if (! $this_error && isset($_POST['hp_coupon_code']) && tep_not_null($_POST['hp_coupon_code'])) {
                    WriteToLog(sprintf(TEXT_PAGE_VIOLATION_HONEYPOT, $_SERVER['REMOTE_ADDR'])); 
                    $this_error = $error = true;
                }
                
                if (! $this_error && (MODULE_HEADER_TAGS_HONEYPOT_ALLOW_EMAIL == 'False' || MODULE_HEADER_TAGS_HONEYPOT_ALLOW_URLS == 'False')) {
                    if (($reslt = InvalidText($enquiry)) != 'good') {
                        if ($reslt != 'failed') {
                            $form_name = GetFormName($page);
                            $messageStack->add($form_name, $reslt);
                        }    
                        $error = true;
                    } 
                }
            }
        }
        
        if ($error) {
            if ($page == 'customer_testimonials_write.php') { //fix sloppy coding for this page
                $testimonials_error = true; 
            }        
        } 
    }	
}