<?php
/*
  $Id$

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2014 osCommerce

  Released under the GNU General Public License
*/

  class ht_honeypot {
    var $code = 'ht_honeypot';
    var $group = 'footer_scripts';
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;

    function __construct() {
      $this->title = MODULE_HEADER_TAGS_HONEYPOT_TITLE;
      $this->description = MODULE_HEADER_TAGS_HONEYPOT_DESCRIPTION;

      if ( defined('MODULE_HEADER_TAGS_HONEYPOT_STATUS') ) {
        $this->sort_order = MODULE_HEADER_TAGS_HONEYPOT_SORT_ORDER;
        $this->enabled = (MODULE_HEADER_TAGS_HONEYPOT_STATUS == 'True');
      }
    }

    function execute() {
      global $PHP_SELF, $oscTemplate;

      if (tep_not_null(MODULE_HEADER_TAGS_HONEYPOT_PAGES)) {
        $pages_array = array();

        foreach (explode(';', MODULE_HEADER_TAGS_HONEYPOT_PAGES) as $page) {
          $page = trim($page);

          if (!empty($page)) {
            $pages_array[] = $page;
          }
        }

        if (in_array(basename($PHP_SELF), $pages_array)) {
          if ((basename($_SERVER['PHP_SELF']) === 'create_account.php')) {
                     $data = '
<script type="text/javascript">
function validateMyForm(create_account) {	
  var ok = check_form(create_account);
  if (! ok) return false;
  return IsSpammer();
}';         
          } else if (basename($_SERVER['PHP_SELF']) === 'contact_us.php' || basename($_SERVER['PHP_SELF']) === 'customer_testimonials_write.php') {   
          $email_allow = (MODULE_HEADER_TAGS_HONEYPOT_ALLOW_EMAIL == 'True' ? 'yes' : 'no');       
          $email_msg   = (MODULE_HEADER_TAGS_HONEYPOT_ALLOW_EMAIL_MSG == 'True' ? 'yes' : 'no');    
          $urls_allow = (MODULE_HEADER_TAGS_HONEYPOT_ALLOW_URLS == 'True' ? 'yes' : 'no');       
          $urls_msg   = (MODULE_HEADER_TAGS_HONEYPOT_ALLOW_URLS_MSG == 'True' ? 'yes' : 'no');    
          
          $data = '
<script type="text/javascript"> 
function validateMyForm() {  
  var email_allow = "' . $email_allow . '"
  var urls_allow = "' . $urls_allow . '"
  var text = document.getElementsByName("enquiry");
  text = text[0].value; 
  var emailsArray = text.match(/([a-zA-Z0-9._-]+@[a-zA-Z0-9._-]+\.[a-zA-Z0-9._-]+)/i);
  var urlsArray = text.match(/(\b(((https?|ftp|file|):\/\/)|www[.])[-A-Z0-9+&@#\/%?=~_|!:,.;]*[-A-Z0-9+&@#\/%=~_|])/i);
  
  if (email_allow == "no" && emailsArray != null && emailsArray.length) {
    if ("' . $email_msg . '" == "yes") {
      alert("Email addresses are not allowed.");
    }
    return false;
  } 
  
  if (urls_allow == "no" && urlsArray != null && urlsArray.length) {
    if ("' . $urls_msg . '" == "yes") {
      alert("URL\'s are not allowed.");
    }
    return false;
  } 
  return IsSpammer();
}'; 
          } else {
          $data = '
<script type="text/javascript">
function validateMyForm() { 
  return IsSpammer();
}';            
          } 
$data .= '       
function IsSpammer() {
  if(!document.getElementById("honeypot").value) {   // The field is empty, submit the form.
    return true;
  } else {   // the field has a value it\'s a spam bot
    return false;
  } 
} 
</script>';
          
         
         $oscTemplate->addBlock($data . "\n" ,  $this->group);
        }
      }
    }

    function isEnabled() {
      return $this->enabled;
    }

    function check() {
      return defined('MODULE_HEADER_TAGS_HONEYPOT_STATUS');
    }

    function install() {
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Honey Pot', 'MODULE_HEADER_TAGS_HONEYPOT_STATUS', 'True', '<center><b><h2>Honey Pot</h2><i>Developed by:</i><br><a href=\"\/\/oscommerce-solution.com\//check_unreleased_updates.php?id=3.3.4&name=HoneyPot\" target=\"_blank\">Oscommerce Solution</a></b></center><br>Do you want to enable the Honey Pot module?<br>', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Pages', 'MODULE_HEADER_TAGS_HONEYPOT_PAGES', '" . implode(';', $this->get_default_pages()) . "', 'The pages to add the Honey Pot scripts to.', '6', '4', 'ht_honeypot_show_pages', 'ht_honeypot_edit_pages(', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_HEADER_TAGS_HONEYPOT_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '5', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Email Addresses Allowed', 'MODULE_HEADER_TAGS_HONEYPOT_ALLOW_EMAIL', 'True', 'Do you want to allow email addresses to be sent via the contact us form?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Email Addresses Show Message', 'MODULE_HEADER_TAGS_HONEYPOT_ALLOW_EMAIL_MSG', 'True', 'Do you want to show a message stating email addresses are not allowed? This is only checked if the Allow Email option is enabled.', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('URL\'s Allowed', 'MODULE_HEADER_TAGS_HONEYPOT_ALLOW_URLS', 'True', 'Do you want to allow url\'s to be sent via the contact us form?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('URL Show Message', 'MODULE_HEADER_TAGS_HONEYPOT_ALLOW_URLS_MSG', 'True', 'Do you want to show a message stating url\'s are not allowed? This is only checked if the Allow Url option is enabled.', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Create Account Check', 'MODULE_HEADER_TAGS_HONEYPOT_CREATE_ACCOUNT_CHECK', 'False', 'Should the create account page be monitored for violations. If disabled, none of the create account options will work.', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Create Account Count', 'MODULE_HEADER_TAGS_HONEYPOT_CREATE_ACCOUNT_CHECK_COUNT', '2', 'The number of accounts a customer can create. Set to a very high number to disable.', '6', '5', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Create Account Period', 'MODULE_HEADER_TAGS_HONEYPOT_CREATE_ACCOUNT_CHECK_PERIOD', '10', 'The number of minutes between create accounts that will cause a failure.', '6', '5', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Block Names with Numbers', 'MODULE_HEADER_TAGS_HONEYPOT_BLOCK_NUMBERS_IN_NAME', 'True', 'Do you want to block any account that has numbes in the first or last name?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");     
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Block Phone with Letters', 'MODULE_HEADER_TAGS_HONEYPOT_BLOCK_LETTERS_IN_PHONE', 'True', 'Do you want to block any account that has letters in the phone or fax entries?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");     
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Name Length - First', 'MODULE_HEADER_TAGS_HONEYPOT_CREATE_ACCOUNT_NAME_LENGTH_FIRST', '2', 'The number of parts of the first name for new accounts. Leave blank to skip this check.', '6', '5', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Name Length - Last', 'MODULE_HEADER_TAGS_HONEYPOT_CREATE_ACCOUNT_NAME_LENGTH_LAST', '1', 'The number of parts of the last name for new accounts. Leave blank to skip this check.', '6', '5', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Verify Domain Referer Match', 'MODULE_HEADER_TAGS_HONEYPOT_VERIFY_REFERER_MATCH', 'True', 'Fails if the domain referer does not match the shop\'s domain name or is empty.', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");     
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Verify Postal Code', 'MODULE_HEADER_TAGS_HONEYPOT_VERIFY_POSTAL_CODE', 'Ignore', 'Allow post codes if they contain at least one number (all post codes do), if they are blank (some countries do not use them), both or ignore this check?', '6', '1', 'tep_cfg_select_option(array(\'Numbers\', \'Blank\', \'Both\', \'Ignore\'), ', now())");     
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Verify State and Country match', 'MODULE_HEADER_TAGS_HONEYPOT_VERIFY_STATE_COUNTRY_MATCH', 'False', 'Do you want to block any account where the state does not exist for the selected country?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");     
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Verify Time to Submit', 'MODULE_HEADER_TAGS_HONEYPOT_VERIFY_TIME_TO_SUBMIT', '', 'If the form is submitted in less time than entered in this setting (in secods), then consider this a spammer.', '6', '5', now())");

      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Show Captcha', 'MODULE_HEADER_TAGS_HONEYPOT_CAPTCHA', 'None', 'Do you want to display a security challenge on the page?', '6', '1', 'tep_cfg_select_option(array(\'Numbers\', \'Image\', \'None\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Use IP List', 'MODULE_HEADER_TAGS_HONEYPOT_USE_IPLIST', 'IPList', 'Do you want to use a list of IP\'s to prevent access? The IP list is created via a cron job so that will have to be set up.', '6', '1', 'tep_cfg_select_option(array(\'IPList\', \'Tor\', \'Both\', \'None\'), ', now())");
      
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Block IP Automatically', 'MODULE_HEADER_TAGS_HONEYPOT_BLOCK_IP_AUTOMATICALLY', '', 'Automatically block the IP after it has reached this many tries. Leave blank to not block the IP.', '6', '5', now())");
    
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Bad Words', 'MODULE_HEADER_TAGS_HONEYPOT_BAD_WORDS', '', 'Enter a comma separated list of words that are not allowed.', '6', '6', 'tep_cfg_textarea(', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Exclude IP\'s', 'MODULE_HEADER_TAGS_HONEYPOT_EXCLUDE_IPS', '', 'A comma-separated list of IP\'s that are not blocked.', '6', '8', now())");      
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Log Tracker', 'MODULE_HEADER_TAGS_HONEYPOT_LOG', 'None', 'Do you want to see all activity Honey Pot monitors? You can save to a file, receive an email or both. The file is named HoneyPot_log and is in the shops includes directory.', '6', '1', 'tep_cfg_select_option(array(\'File\', \'EMail\', \'Both\', \'None\'), ', now())");     
    }

    function remove() {
      tep_db_query("delete from configuration where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_HEADER_TAGS_HONEYPOT_STATUS', 
                   'MODULE_HEADER_TAGS_HONEYPOT_PAGES', 
                   'MODULE_HEADER_TAGS_HONEYPOT_SORT_ORDER', 
                   'MODULE_HEADER_TAGS_HONEYPOT_ALLOW_EMAIL', 
                   'MODULE_HEADER_TAGS_HONEYPOT_ALLOW_EMAIL_MSG', 
                   'MODULE_HEADER_TAGS_HONEYPOT_ALLOW_URLS', 
                   'MODULE_HEADER_TAGS_HONEYPOT_ALLOW_URLS_MSG',
                   'MODULE_HEADER_TAGS_HONEYPOT_CREATE_ACCOUNT_CHECK',
                   'MODULE_HEADER_TAGS_HONEYPOT_CREATE_ACCOUNT_CHECK_COUNT',
                   'MODULE_HEADER_TAGS_HONEYPOT_CREATE_ACCOUNT_CHECK_PERIOD', 
                   'MODULE_HEADER_TAGS_HONEYPOT_BLOCK_NUMBERS_IN_NAME', 
                   'MODULE_HEADER_TAGS_HONEYPOT_BLOCK_LETTERS_IN_PHONE', 
                   'MODULE_HEADER_TAGS_HONEYPOT_CREATE_ACCOUNT_NAME_LENGTH_FIRST', 
                   'MODULE_HEADER_TAGS_HONEYPOT_CREATE_ACCOUNT_NAME_LENGTH_LAST', 
                   'MODULE_HEADER_TAGS_HONEYPOT_VERIFY_POSTAL_CODE', 
                   'MODULE_HEADER_TAGS_HONEYPOT_VERIFY_REFERER_MATCH', 	   
                   'MODULE_HEADER_TAGS_HONEYPOT_VERIFY_STATE_COUNTRY_MATCH',
                   'MODULE_HEADER_TAGS_HONEYPOT_VERIFY_TIME_TO_SUBMIT',		   
                   'MODULE_HEADER_TAGS_HONEYPOT_CAPTCHA', 
                   'MODULE_HEADER_TAGS_HONEYPOT_USE_IPLIST', 
                   'MODULE_HEADER_TAGS_HONEYPOT_BLOCK_IP_AUTOMATICALLY', 
                   'MODULE_HEADER_TAGS_HONEYPOT_BAD_WORDS', 
                   'MODULE_HEADER_TAGS_HONEYPOT_EXCLUDE_IPS', 
                   'MODULE_HEADER_TAGS_HONEYPOT_LOG');
    }

    function get_default_pages() {
      return array('contact_us.php',
                   'create_account.php',
                   'tell_a_friend.php');
    }
  }

  function ht_honeypot_show_pages($text) {
    return nl2br(implode("\n", explode(';', $text)));
  }

  function ht_honeypot_edit_pages($values, $key) {
    global $PHP_SELF;

    $file_extension = substr($PHP_SELF, strrpos($PHP_SELF, '.'));
    $files_array = array();
	  if ($dir = @dir(DIR_FS_CATALOG)) {
	    while ($file = $dir->read()) {
	      if (!is_dir(DIR_FS_CATALOG . $file)) {
	        if (substr($file, strrpos($file, '.')) == $file_extension) {
            $files_array[] = $file;
          }
        }
      }
      sort($files_array);
      $dir->close();
    }

    $values_array = explode(';', $values);

    $output = '';
    foreach ($files_array as $file) {
      $output .= tep_draw_checkbox_field('ht_honeypot_file[]', $file, in_array($file, $values_array)) . '&nbsp;' . tep_output_string($file) . '<br />';
    }

    if (!empty($output)) {
      $output = '<br />' . substr($output, 0, -6);
    }

    $output .= tep_draw_hidden_field('configuration[' . $key . ']', '', 'id="htrn_files"');

    $output .= '<script>
                function htrn_update_cfg_value() {
                  var htrn_selected_files = \'\';

                  if ($(\'input[name="ht_honeypot_file[]"]\').length > 0) {
                    $(\'input[name="ht_honeypot_file[]"]:checked\').each(function() {
                      htrn_selected_files += $(this).attr(\'value\') + \';\';
                    });

                    if (htrn_selected_files.length > 0) {
                      htrn_selected_files = htrn_selected_files.substring(0, htrn_selected_files.length - 1);
                    }
                  }

                  $(\'#htrn_files\').val(htrn_selected_files);
                }

                $(function() {
                  htrn_update_cfg_value();

                  if ($(\'input[name="ht_honeypot_file[]"]\').length > 0) {
                    $(\'input[name="ht_honeypot_file[]"]\').change(function() {
                      htrn_update_cfg_value();
                    });
                  }
                });
                </script>';

    return $output;
  }
  
