<?php
/*
  $Id: customer_testimonials_write.php, v2.4bs 17th Oct. 2016 auzStar (Dominic C.) $
  Customer Testimonials for osCommerce 2.3.4 bootstrap - v2.4bs

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2016 osCommerce

  Released under the GNU General Public License
*/

  require('includes/application_top.php');

  // Redirect user to home page if Admin has disabled Customer Testimonials mod or disabled the write testimonials option
  // The user should not be able to get to this module in that state, but just in case
  // We check for it to prevent problems
  if (!defined('TESTIMONIAL_ACTIVE') || TESTIMONIAL_ACTIVE != 'Yes' || TESTIMONIAL_REGISTERED_WRITE == "Disabled") {
    tep_redirect(tep_href_link('index.php'));
  }

  // Redirect user to login page if:
  // only registered users are permitted to write testimonials and user is not logged in
  if (TESTIMONIAL_REGISTERED_WRITE == "Registered Users Only" && !tep_session_is_registered('customer_id')) {
    $navigation->set_snapshot();
    tep_redirect(tep_href_link('login.php', '', 'SSL'));
  }

  require('includes/languages/' . $language . '/customer_testimonials_write.php');

  $too_soon_errormessage = false;
  $email_error = false;
  $testimonials_error = false;
  if (isset($_GET['action']) && ($_GET['action'] == 'insert')) {
    $testimonials_title = tep_db_prepare_input($_POST['testimonials_title']);
    $testimonials_name = tep_db_prepare_input($_POST['testimonials_name']);
    $testimonials_email = tep_db_prepare_input($_POST['testimonials_email']);
    $testimonials_location = tep_db_prepare_input($_POST['testimonials_location']);
    $testimonial = tep_db_prepare_input($_POST['testimonial']);

    $actionRecorder = new actionRecorder('ar_testimonials_write', (tep_session_is_registered('customer_id') ? $customer_id : null), $testimonials_name);
    if (!$actionRecorder->canPerform()) {
      $testimonials_error = true;
      $actionRecorder->record(false);
      $too_soon_errormessage = true;
    }

    if (empty($testimonials_name)) {
      $testimonials_error = true;
      $messageStack->add('testimonials', ERROR_TESTIMONIALS_WRITE_NAME_REQUIRED);
    }
	if (empty($testimonials_email)) {
      $email_error = true;
      $testimonials_error = true;
      $messageStack->add('testimonials', ERROR_TESTIMONIALS_WRITE_EMAIL_REQUIRED);
    } else if (!tep_validate_email($testimonials_email)) {
      $email_error = true;
      $testimonials_error = true;
      $messageStack->add('testimonials', ERROR_TESTIMONIALS_WRITE_EMAIL_ADDRESS_CHECK);
	}
    if (empty($testimonials_title)) {
      $testimonials_error = true;
      $messageStack->add('testimonials', ERROR_TESTIMONIALS_WRITE_TITLE_REQUIRED);
    }
    
    if (empty($testimonial)) {
      $testimonials_error = true;
      $messageStack->add('testimonials', ERROR_TESTIMONIALS_WRITE_DESCRIPTION_REQUIRED);
    } else if (strpos($testimonial, 'http') !== false || strpos($$testimonial, 'www.') !== false) {
      $testimonials_error = true;
      $messageStack->add('testimonials', ERROR_TESTIMONIALS_WRITE_DESCRIPTION_HAS_URL);    
      AlterHtaccessFile($_SERVER['REMOTE_ADDR']);      
    }

    /*** BEGIN HONEYPOT ***/
    include('includes/honeypot/modules/honeypot_verify_general.php');
    /*** END HONEYPOT ***/ 

    if (! $testimonials_error) {
      $testimonial_image_name = '';
      if (TESTIMONIAL_IMAGE_ALLOW == 'Yes') {
        // file uploading class
        require('includes/classes/upload.php');
        // make sure testimonials directory exists for testimonial image uploads
	    if (!is_dir('images/testimonials')) mkdir('images/testimonials', '777');
	    $testimonial_image = new upload('testimonial_image');
        $testimonial_image->set_destination('images/testimonials/');
        $imagefiletypes = array('jpg','jpeg','gif','png','bmp');
        $testimonial_image->set_extensions($imagefiletypes);
        if ($testimonial_image->parse() && $testimonial_image->save()) {
          $testimonial_image_name = $testimonial_image->filename;
        }
      }

      $sql_data_array = array('testimonials_title' => $testimonials_title,
							  'testimonials_location' => $testimonials_location,
                              'testimonials_name' => $testimonials_name,
							  'testimonials_email' => $testimonials_email,
                              'testimonials_html_text' => $testimonial,
							  'testimonial_image' => $testimonial_image_name,
							  'language_id' => (int)$languages_id,
                              'date_added' => 'now()',
                              'status' => '0');

      tep_db_perform('customer_testimonials', $sql_data_array);

      require('includes/languages/' . TESTIMONIAL_ADMIN_EMAIL . '/customer_testimonials_admin_email.php');

	  $languages_query = tep_db_query("select languages_id from languages");
	  $num_languages = tep_db_num_rows($languages_query);

      $email_text = EMAIL_TESTIMONIAL_TEXT . $testimonials_name . (tep_not_null($testimonials_location) ? EMAIL_TESTIMONIAL_OF . $testimonials_location : '') . '.' . "\n\n" .
                    EMAIL_TESTIMONIAL_TITLE . $testimonials_title . "\n\n" .
                    EMAIL_TESTIMONIAL_HTML_TEXT . $testimonial . "\n\n" . ($num_languages > 1 ? EMAIL_TESTIMONIAL_LANGUAGE_TEXT . $language . "\n\n" : '') .
                    EMAIL_TESTIMONIAL_APPROVE;
      tep_mail(STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS, EMAIL_TESTIMONIAL_SUBJECT, $email_text, $testimonials_name, $testimonials_email);

      if (isset($_POST['send_copy']) && ($_POST['send_copy'] == '1')) {
        $email_copy_text = EMAIL_TESTIMONIALS_COPY_TEXT . "\n\n" .
                           EMAIL_TESTIMONIAL_TITLE . $testimonials_title . "\n\n" .
                           EMAIL_TESTIMONIAL_HTML_TEXT . $testimonial;
        tep_mail($testimonials_name, $testimonials_email, EMAIL_TESTIMONIAL_SUBJECT, $email_copy_text, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);
      }

      $messageStack->add_session('customer_testimonials', TEXT_TESTIMONIALS_SUCCESS, 'success');
      $actionRecorder->record();
      tep_redirect(tep_href_link('customer_testimonials.php'));
    } else {
      if (TESTIMONIAL_IMAGE_ALLOW == 'Yes') {
        $messageStack->add('testimonials', WARNING_TESTIMONIALS_WRITE_UPLOAD_IMAGE_AGAIN, 'warning');
      }
    }
  } else {

    $actionRecorder = new actionRecorder('ar_testimonials_write');
    if (!$actionRecorder->canPerform()) {
      $too_soon_errormessage = true;
    }

  }

  if (tep_session_is_registered('customer_id') && !isset($_GET['action'])) {
    $account_query = tep_db_query("select c.customers_firstname, c.customers_lastname, c.customers_email_address, ab.entry_suburb, ab.entry_city, ab.entry_state, ab.entry_country_id, ab.entry_zone_id, country.countries_iso_code_3 from customers c left join address_book ab on (c.customers_id = ab.customers_id and c.customers_default_address_id = ab.address_book_id) left join countries country on country.countries_id = ab.entry_country_id where c.customers_id = '" . (int)$customer_id . "'");
    $account = tep_db_fetch_array($account_query);

    $testimonials_name = tep_output_string_protected($account['customers_firstname'] . ' ' . $account['customers_lastname']);
    $testimonials_email = $account['customers_email_address'];

    // (NOTE: you can comment out which ever line below for $account_state depending on whether you want state name or state code to appear)
    //$account_state = tep_get_zone_name($account['entry_country_id'], $account['entry_zone_id'], $account['entry_state']); // state name
    $account_state = tep_get_zone_code($account['entry_country_id'], $account['entry_zone_id'], $account['entry_state']); // state code

    $testimonials_location = tep_output_string_protected((tep_not_null($account['entry_city']) ? $account['entry_city'] : $account['entry_suburb']) . ' ' . $account_state . ' (' . $account['countries_iso_code_3'] . ')');
  }

  $breadcrumb->add(NAVBAR_TITLE_WRITE, tep_href_link('customer_testimonials_write.php', '', 'SSL'));

  $oscTemplate->addBlock('<link href="ext/modules/customer_testimonials.css" rel="stylesheet">' . "\n", 'header_tags');

  require('includes/template_top.php');
?>

<style> span#show_less_info, span#more_info { display: none; } </style>

<div class="page-header">
  <h1><?php echo HEADING_TITLE_WRITE; ?></h1>
</div>

<?php
  if ($messageStack->size('testimonials') > 0 || $too_soon_errormessage) {

    if ($too_soon_errormessage) {
      $messageStack->add('too_soon_message', sprintf(ERROR_ACTION_RECORDER, (defined('MODULE_ACTION_RECORDER_TESTIMONIALS_WRITE_MINUTES') ? (int)MODULE_ACTION_RECORDER_TESTIMONIALS_WRITE_MINUTES : 15)), 'warning');

      if ($messageStack->size('too_soon_message') > 0)
        echo $messageStack->output('too_soon_message');
    }

    if ($messageStack->size('testimonials') > 0)
      echo $messageStack->output('testimonials');

  }
?>

<div class="alert alert-info alert-dismissible">
  <button type="button" class="close visible-xs" data-dismiss="alert">&times;</button>
  <?php echo TEXT_TESTIMONIALS_WRITE_INTRO . '<span id="show_more_info" class="read_more">....' . LINK_READ_MORE . '</span><span id="show_less_info" class="read_more">....' . LINK_SHOW_LESS . '</span>'; ?>
  <span id="more_info"><?php echo TEXT_TESTIMONIALS_WRITE_INTRO_2; ?></span>
</div>

<?php //BEGIN HONEYPOT ?>
<?php echo tep_draw_form('customer_testimonial', tep_href_link('customer_testimonials_write.php', 'action=insert', 'SSL'), 'post', 'class="form-horizontal" enctype="multipart/form-data" onsubmit="return validateMyForm();"', true); ?>
<?php //END HONEYPOT ?>

<div class="contentContainer">
  <div class="contentText">

    <p class="inputRequirement text-right"><?php echo FORM_REQUIRED_INFORMATION; ?></p>

    <div class="form-group has-feedback">
      <label for="inputName" class="control-label col-sm-3"><?php echo ENTRY_TESTIMONIALS_WRITE_NAME; ?></label>
      <div class="col-sm-9">
        <?php
        echo tep_draw_input_field('testimonials_name', (isset($testimonials_name) ? $testimonials_name : ''), 'required aria-required="true" id="inputName" placeholder="' . ENTRY_TESTIMONIALS_WRITE_NAME_TEXT . '"');
        echo FORM_REQUIRED_INPUT;
        ?>
      </div>
    </div>
    <div class="form-group <?php echo ($email_error ? 'has-error' : '') ?> has-feedback">
      <label for="inputEmail" class="control-label col-sm-3"><?php echo ENTRY_TESTIMONIALS_WRITE_EMAIL; ?></label>
      <div class="col-sm-9">
        <?php
        echo tep_draw_input_field('testimonials_email', (isset($testimonials_email) ? $testimonials_email : ''), 'required aria-required="true" id="inputEmail" placeholder="' . ENTRY_TESTIMONIALS_WRITE_EMAIL_TEXT . '"');
        echo FORM_REQUIRED_INPUT;
        ?>
      </div>
    </div>
    <div class="form-group">
    <label for="inputLocation" class="control-label col-sm-3"><?php echo ENTRY_TESTIMONIALS_WRITE_LOCATION; ?></label>
      <div class="col-sm-9">
        <?php
        echo tep_draw_input_field('testimonials_location', (isset($testimonials_location) ? $testimonials_location : ''), 'id="inputLocation" placeholder="' . ENTRY_TESTIMONIALS_WRITE_LOCATION_TEXT . '"');
        ?>
      </div>
    </div>
    <div class="form-group has-feedback">
      <label for="inputTitle" class="control-label col-sm-3"><?php echo ENTRY_TESTIMONIALS_WRITE_TITLE; ?></label>
      <div class="col-sm-9">
        <?php
        echo tep_draw_input_field('testimonials_title', (isset($testimonials_title) ? $testimonials_title : ''), 'required aria-required="true" id="inputTitle" placeholder="' . ENTRY_TESTIMONIALS_WRITE_TITLE_TEXT . '"');
        echo FORM_REQUIRED_INPUT;
        ?>
      </div>
    </div>
    <div class="form-group has-feedback">
      <label for="inputTestimonial" class="control-label col-sm-3"><?php echo ENTRY_TESTIMONIALS_WRITE_HTML_TEXT; ?></label>
      <div class="col-sm-9">
        <?php
        echo tep_draw_textarea_field('testimonial', 'soft', '130', '10', (isset($testimonial) ? $testimonial : ''), 'required aria-required="true" id="inputTestimonial" placeholder="' . ENTRY_TESTIMONIALS_WRITE_TESTIMONIAL_TEXT . '" style="resize: none;"');
        echo FORM_REQUIRED_INPUT;
        ?>
      </div>
    </div>

<?php
  if (TESTIMONIAL_IMAGE_ALLOW == 'Yes') {
?>

    <div class="form-group <?php echo ($testimonials_error ? 'has-warning' : '') ?>">
    <label for="inputImage" class="control-label col-sm-3"><?php echo ENTRY_TESTIMONIALS_WRITE_UPLOAD_IMAGE; ?></label>
      <div class="col-sm-9">
        <?php
        echo tep_draw_input_field('testimonial_image', '', 'id="inputImage" style="height: auto;"', 'file');
        ?>
      </div>
    </div>

<?php
  }
?>

    <div class="form-group">
      <label for="inputCopy" class="control-label hidden-xs col-sm-3"><?php echo ENTRY_TESTIMONIALS_SEND_COPY; ?></label>
      <div class="checkbox col-xs-12 col-sm-9">
        <label>
          <?php
            echo tep_draw_checkbox_field('send_copy', '1', NULL, 'id="inputCopy"');
            echo ' <span class="visible-xs" style="padding-top: 1px;"><strong>' . ENTRY_TESTIMONIALS_SEND_COPY . '</strong></span>';
		  ?>
        </label>
      </div>
    </div>
    
  <?php
  /*** BEGIN HONEYPOT ***/
  include('includes/honeypot/modules/honeypot_display.php');
  /*** END HONEYPOT ***/  
  ?>
  
  </div>

  <br />

  <div class="buttonSet row">
      <div class="col-xs-6"><?php echo tep_draw_button(IMAGE_BUTTON_BACK, 'fa fa-angle-left', tep_href_link('customer_testimonials.php')); ?></div>
	  <div class="col-xs-6 text-right"><?php echo tep_draw_button(IMAGE_BUTTON_SUBMIT_TESTIMONIAL, 'fa fa-angle-right', null, 'primary', null, 'btn-success'); ?></div>
  </div>

  <br />

</div>

</form>

<noscript><style> span#show_more_info { display: none; } span#more_info { display: inline; } </style></noscript>

<script type="text/javascript">
$(function(){

  $("span#show_more_info").click(function() {
    $("span#more_info").show();
    $(this).hide();
    $("span#show_less_info").show();
  }).on('selectstart', function (event) {
    event.preventDefault();
  });

  $("span#show_less_info").click(function() {
    $("span#more_info").hide();
    $(this).hide();
    $("span#show_more_info").show();
  }).on('selectstart', function (event) {
    event.preventDefault();
  });
});
</script>

<?php
  require('includes/template_bottom.php');
  require('includes/application_bottom.php');
?>
