<?php
$saved_locn = '';
$config = file(dirname(__FILE__) . '/includes/configure.php');

echo "Find configure file\n";

foreach ($config as $line) {
    if (strpos($line, 'DIR_FS_CATALOG') !== FALSE) { 
        $path = explode(',', $line);
        $saved_locn = str_replace(['\'', ')', ';'], '', trim($path[1])) . 'includes/honeypot/iplist.txt';
        break;
    }
} 

echo "Load saved file ".$saved_locn."\n";

$saved_list = array();
if (file_exists($saved_locn)) {
    $saved_list = file($saved_locn, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
}

echo "Retrieving IP list\n";

$zipURL = "https://myip.ms/files/blacklist/general/latest_blacklist.txt";
$new_list = file($zipURL);

if ($new_list == FALSE) {
    echo 'failed to retrieve list<br>'."\n";
    exit;
} else {
    echo "IP List retrieved.\n";
} 
    
 //echo 'cnt '.count($saved_list);
$cnt_orig = sizeof($saved_list);
$cnt = 0;

if (is_array($new_list) && sizeof($new_list)) { 
    foreach($new_list as $line) {
       if ($line[0] == '#') continue;
       if (empty($line)) continue;
       
       $ip = array_map('trim', explode('#', $line));
       
      // echo 'Compare IP ' .$ip[0] . '<br>' ."\n";       

       if (!empty($ip[0]) && ! in_array($ip[0], $saved_list)) {       
          // echo 'Added ' . $ip[0] .'<br>'."\n";
           $saved_list[] = $ip[0]; 
           $cnt++;
       }   
    }
}
 
if ($cnt) {
    $mode = 'w';

    if (($fp = fopen($saved_locn , $mode))) {    
        foreach($saved_list as $line) {
            fwrite($fp, $line .PHP_EOL);
        }    
        fclose($fp);  
    } else echo "\n" . 'Failed to open '.$saved_locn;  
    
    $size = filesize($saved_locn);
    $base = log($size, 1024);
    $precision = 2;
    $suffixes = array('B', 'KB', 'MB', 'GB', 'TB');  
    $filesize = round(pow(1024, $base - floor($base)), $precision) .' '. $suffixes[floor($base)]; 

    echo "\n" . 'IP\'s added: ' . $cnt . '. Total count now is ' . ($cnt_orig + $cnt) . ' Size of the file is = ' . $filesize . "\n";
    
}
exit;
 
   