<?php
/*******************************************************************************
Check to see if this customer has created an account in a certain period of time.
Returns true if they have.
/******************************************************************************/
function CheckCreateAccountHP($all_fields) { 
    $cust = $all_fields['firstname'] . ' ' . $all_fields['lastname']; 
    
    if (MODULE_HEADER_TAGS_HONEYPOT_BLOCK_NUMBERS_IN_NAME == 'True') {
        if (preg_match("/\d/", $cust)) {   
            return true;      //block but could be a mistake
        }    
    }
	
    if (MODULE_HEADER_TAGS_HONEYPOT_BLOCK_LETTERS_IN_PHONE == 'True') {
        $str = $all_fields['telephone'] . $all_fields['fax']; 
        for ($i = 0; $i < strlen($str); $i++) {
            if (ctype_alpha($str[$i])) {   
                return true;  //block but could be a mistake
            }
        }	  
    }	
	
    if (tep_not_null(MODULE_HEADER_TAGS_HONEYPOT_CREATE_ACCOUNT_NAME_LENGTH_FIRST)) {
        if (str_word_count($all_fields['firstname']) > MODULE_HEADER_TAGS_HONEYPOT_CREATE_ACCOUNT_NAME_LENGTH_FIRST) {
            return true;      //block but could be a mistake
        }			
    }	
       
    if (tep_not_null(MODULE_HEADER_TAGS_HONEYPOT_CREATE_ACCOUNT_NAME_LENGTH_LAST)) {
        if (str_word_count($all_fields['lastname']) > MODULE_HEADER_TAGS_HONEYPOT_CREATE_ACCOUNT_NAME_LENGTH_LAST) {
            return true;      //block but could be a mistake
        }			
    }	
    
    if (CheckHTMLTags($all_fields)) {
        return true;                   
    } 
     

    return false; 
}

function CheckCountryState($state, $country) {
    $db_query = tep_db_query("select 1 from zones where zone_country_id = '" . tep_db_input($country) . "' and zone_id = '" . tep_db_input($state) . "'");
    return (tep_db_num_rows($db_query) ? false : true);
}
 
function CheckHTMLTags($all_fields) {
    foreach ($all_fields as $item) {
        if($item != strip_tags($item)) {
            return true; // contains HTML
        }
    } 
    return false;
}

function CheckPostalCode($postcode, $country) {

        if (empty($postcode)) return true;
            
        $has_numbers = false;
        for ($i = 0; $i < strlen($postcode); ++$i) {
            if (ctype_digit($postcode[$i])) {
                $has_numbers = true; 
            }    
        }    
        if (! $has_numbers) return true;
        
            $ZIPREG=array(
             "AD"=>"^AD\d{3}?$",
             "AM"=>"^(37)?\d{4}?$",
             "AR"=>"^([A-HJ-NP-Z])?\d{4}([A-Z]{3})?$",
             "AS"=>"^96799?$",
             "AT"=>"^\d{4}?$",
             "AU"=>"^(0[289][0-9]{2})|([1345689][0-9]{3})|(2[0-8][0-9]{2})|(290[0-9])|(291[0-4])|(7[0-4][0-9]{2})|(7[8-9][0-9]{2})?$",
             "AX"=>"^22\d{3}?$",
             "AZ"=>"^\d{4}?$",
             "BA"=>"^\d{5}?$",
             "BB"=>"^(BB\d{5})?$",
             "BD"=>"^\d{4}?$",
             "BE"=>"^[1-9]{1}[0-9]{3}?$",
             "BG"=>"^\d{4}?$",
             "BH"=>"^((1[0-2]|[2-9])\d{2})?$",
             "BM"=>"^[A-Z]{2}[ ]?[A-Z0-9]{2}?$",
             "BN"=>"^[A-Z]{2}[ ]?\d{4}?$",
             "BR"=>"^\d{5}[\-]?\d{3}?$",
             "BY"=>"^\d{6}?$",
             "CA"=>"^([ABCEGHJKLMNPRSTVXY]\d[ABCEGHJKLMNPRSTVWXYZ])\ {0,1}(\d[ABCEGHJKLMNPRSTVWXYZ]\d)?$",
             "CC"=>"^6799?$",
             "CH"=>"^\d{4}?$",
             "CK"=>"^\d{4}?$",
             "CL"=>"^\d{7}?$",
             "CN"=>"^\d{6}?$",
             "CR"=>"^\d{4,5}|\d{3}-\d{4}?$",
             "CS"=>"^\d{5}?$",
             "CV"=>"^\d{4}?$",
             "CX"=>"^6798?$",
             "CY"=>"^\d{4}?$",
             "CZ"=>"^\d{3}[ ]?\d{2}?$",
             "DK"=>"^([D-d][K-k])?( |-)?[1-9]{1}[0-9]{3}?$",
             "DO"=>"^\d{5}?$",
             "DZ"=>"^\d{5}?$",
             "EC"=>"^([A-Z]\d{4}[A-Z]|(?:[A-Z]{2})?\d{6})?$",
             "EE"=>"^\d{5}?$",
             "EG"=>"^\d{5}?$",
             "ES"=>"^([1-9]{2}|[0-9][1-9]|[1-9][0-9])[0-9]{3}?$",
             "ET"=>"^\d{4}?$",
             "FI"=>"^\d{5}?$",
             "FK"=>"^FIQQ 1ZZ?$",
             "FM"=>"^(9694[1-4])([ \-]\d{4})?$",
             "FO"=>"^\d{3}?$",
             "FR"=>"^(F-)?((2[A|B])|[0-9]{2})[0-9]{3}?$",
             "GB"=>"^(GIR|[A-Z]\d[A-Z\d]??|[A-Z]{2}\d[A-Z\d]??)[ ]??(\d[A-Z]{2})?$",
             "GE"=>"^\d{4}?$",
             "GF"=>"^9[78]3\d{2}?$",
             "GG"=>"^GY\d[\dA-Z]?[ ]?\d[ABD-HJLN-UW-Z]{2}?$",
             "GL"=>"^39\d{2}?$",
             "GN"=>"^\d{3}?$",
             "GP"=>"^9[78][01]\d{2}?$",
             "GR"=>"^\d{3}[ ]?\d{2}?$",
             "GS"=>"^SIQQ 1ZZ?$",
             "GT"=>"^\d{5}?$",
             "GU"=>"^969[123]\d([ \-]\d{4})?$",
             "GW"=>"^\d{4}?$",
             "HM"=>"^\d{4}?$",
             "HN"=>"^(?:\d{5})?$",
             "HR"=>"^\d{5}?$",
             "HT"=>"^\d{4}?$",
             "HU"=>"^\d{4}?$",
             "ID"=>"^\d{5}?$",
             "IL"=>"^\d{5}?$",
             "IM"=>"^IM\d[\dA-Z]?[ ]?\d[ABD-HJLN-UW-Z]{2}?$",
             "IN"=>"^\d{6}?$",
             "IO"=>"^BBND 1ZZ?$",
             "IQ"=>"^\d{5}?$",
             "IS"=>"^\d{3}?$",
             "IT"=>"^(V-|I-)?[0-9]{5}?$",
             "JE"=>"^JE\d[\dA-Z]?[ ]?\d[ABD-HJLN-UW-Z]{2}?$",
             "JO"=>"^\d{5}?$",
             "JP"=>"^\d{3}-\d{4}?$",
             "KE"=>"^\d{5}?$",
             "KG"=>"^\d{6}?$",
             "KH"=>"^\d{5}?$",
             "KR"=>"^\d{3}[\-]\d{3}?$",
             "KW"=>"^\d{5}?$",
             "KZ"=>"^\d{6}?$",
             "LA"=>"^\d{5}?$",
             "LB"=>"^(\d{4}([ ]?\d{4})?)?$",
             "LI"=>"^(948[5-9])|(949[0-7])?$",
             "LK"=>"^\d{5}?$",
             "LR"=>"^\d{4}?$",
             "LS"=>"^\d{3}?$",
             "LT"=>"^\d{5}?$",
             "LU"=>"^\d{4}?$",
             "LV"=>"^\d{4}?$",
             "MA"=>"^\d{5}?$",
             "MC"=>"^980\d{2}?$",
             "MD"=>"^\d{4}?$",
             "ME"=>"^8\d{4}?$",
             "MG"=>"^\d{3}?$",
             "MH"=>"^969[67]\d([ \-]\d{4})?$",
             "MK"=>"^\d{4}?$",
             "MN"=>"^\d{6}?$",
             "MP"=>"^9695[012]([ \-]\d{4})?$",
             "MQ"=>"^9[78]2\d{2}?$",
             "MT"=>"^[A-Z]{3}[ ]?\d{2,4}?$",
             "MU"=>"^(\d{3}[A-Z]{2}\d{3})?$",
             "MV"=>"^\d{5}?$",
             "MX"=>"^\d{5}?$",
             "MY"=>"^\d{5}?$",
             "NC"=>"^988\d{2}?$",
             "NE"=>"^\d{4}?$",
             "NF"=>"^2899?$",
             "NG"=>"^(\d{6})?$",
             "NI"=>"^((\d{4}-)?\d{3}-\d{3}(-\d{1})?)?$",
             "NL"=>"^[1-9][0-9]{3}\s?([a-zA-Z]{2})?$",
             "NO"=>"^\d{4}?$",
             "NP"=>"^\d{5}?$",
             "NZ"=>"^\d{4}?$",
             "OM"=>"^(PC )?\d{3}?$",
             "PF"=>"^987\d{2}?$",
             "PG"=>"^\d{3}?$",
             "PH"=>"^\d{4}?$",
             "PK"=>"^\d{5}?$",
             "PL"=>"^\d{2}-\d{3}?$",
             "PM"=>"^9[78]5\d{2}?$",
             "PN"=>"^PCRN 1ZZ?$",
             "PR"=>"^00[679]\d{2}([ \-]\d{4})?$",
             "PT"=>"^\d{4}([\-]\d{3})?$",
             "PW"=>"^96940?$",
             "PY"=>"^\d{4}?$",
             "RE"=>"^9[78]4\d{2}?$",
             "RO"=>"^\d{6}?$",
             "RS"=>"^\d{6}?$",
             "RU"=>"^\d{6}?$",
             "SA"=>"^\d{5}?$",
             "SE"=>"^(s-|S-){0,1}[0-9]{3}\s?[0-9]{2}?$",
             "SG"=>"^\d{6}?$",
             "SH"=>"^(ASCN|STHL) 1ZZ?$",
             "SI"=>"^\d{4}?$",
             "SJ"=>"^\d{4}?$",
             "SK"=>"^\d{3}[ ]?\d{2}?$",
             "SM"=>"^4789\d?$",
             "SN"=>"^\d{5}?$",
             "SO"=>"^\d{5}?$",
             "SZ"=>"^[HLMS]\d{3}?$",
             "TC"=>"^TKCA 1ZZ?$",
             "TH"=>"^\d{5}?$",
             "TJ"=>"^\d{6}?$",
             "TM"=>"^\d{6}?$",
             "TN"=>"^\d{4}?$",
             "TR"=>"^\d{5}?$",
             "TW"=>"^\d{3}(\d{2})?$",
             "UA"=>"^\d{5}?$",
             "US"=>"^\d{5}([\-]?\d{4})?$",
             "UY"=>"^\d{5}?$",
             "UZ"=>"^\d{6}?$",
             "VA"=>"^00120?$",
             "VE"=>"^\d{4}?$",
             "VI"=>"^008(([0-4]\d)|(5[01]))([ \-]\d{4})?$",
             "WF"=>"^986\d{2}?$",
             "XK"=>"^\d{5}?$",
             "YT"=>"^976\d{2}?$",
             "YU"=>"^\d{5}?$",
             "ZA"=>"^\d{4}?$",
             "ZM"=>"^\d{5}?$"
            );
            $db_query = tep_db_query("select countries_iso_code_2 from countries where countries_id = '" . tep_db_input($country) . "'");
            if (tep_db_num_rows($db_query)) {
                $db = tep_db_fetch_array($db_query);
                if (isset($ZIPREG[$db['countries_iso_code_2']]) && ! preg_match("/".$ZIPREG[$db['countries_iso_code_2']]."/i",$postcode)) {
                    return true;             
                }  
            }
 
    return false;    
}     

/**********************************************
Common function to delete an invalid customer
**********************************************/
function DeleteCustomer($customers_id) {
    tep_db_query("DELETE r, rd FROM reviews r LEFT JOIN reviews_description rd ON r.reviews_id = rd.reviews_id WHERE r.customers_id = " . (int)$customers_id);
    tep_db_query("DELETE FROM address_book WHERE customers_id = " . (int)$customers_id);
    tep_db_query("DELETE FROM customers WHERE customers_id = " . (int)$customers_id);
    tep_db_query("DELETE FROM customers_info WHERE customers_info_id = " . (int)$customers_id);
    tep_db_query("DELETE FROM customers_basket WHERE customers_id = " . (int)$customers_id);
    tep_db_query("DELETE FROM customers_basket_attributes WHERE customers_id = " . (int)$customers_id);
    tep_db_query("DELETE FROM whos_online WHERE customer_id = " . (int)$customers_id);               
}

/**********************************************
Get the State and Country names, if found
**********************************************/
function GetStateCountry($zone_id, $country) {
    $db_query = tep_db_query("select c.countries_name, z.zone_name from zones z left join countries c on z.zone_country_id = c.countries_id  where zone_country_id = '" . tep_db_input($country) . "' and zone_id = '" . tep_db_input($zone_id) . "'");
    if (tep_db_num_rows($db_query)) {
        $db = tep_db_fetch_array($db_query);
        return $db['zone_name'] . ',' . $db['countries_name'];
    }
    return TEXT_STATE_COUNTRY_MISMATCH;
} 

/*******************************************************************************
Remove the blocked the from the .htaccess file
/******************************************************************************/
function RemoveFromHtAccess($ip) {
    $htaccessfile = '';
    $separator = ((substr(DIR_FS_CATALOG, -1) != '/') ? '/' : '');
    $htaccessfile = DIR_FS_CATALOG . $separator . '.htaccess';
    
    if ($htaccessfile && file_exists($htaccessfile)) {
        $htaccessArray = file($htaccessfile);
        $lineToRemove = 'deny from ' . $ip . PHP_EOL;
        $fp = fopen($htaccessfile, "w" );
        if ($fp) {
            if (flock($fp, LOCK_EX)) {
                foreach ($htaccessArray as $line) {
                   if (trim($line) != trim($lineToRemove)) {
                       fputs($fp, $line);    
                   }            
                }
                
                fflush($fp);    // release lock
                flock($fp, LOCK_UN); 
            }                
            fclose($fp);
        }        
    }   
}